#include <iostream>
#include <fstream>

#include "lsgen.hpp"
#include "lsparser.hpp"
#include "lsgenerator.hpp"
#include "lsgrinter.hpp"

int
main(int argc, char** argv)
{
	char const* inname;
	char const* outname;

	if (argc > 2) {
		inname = argv[1];
		outname = argv[2];
	} else {
		std::cerr << "Error: Provide input and output file, see documentation." << std::endl;
		return 1;
	}

	Lsparser par(inname);
	
	if(par.parse()) {
		std::cerr << "Input parsed ..." << std::endl;
	} else {
		std::cerr << par.error << std::endl;
	}


	Lsgenerator gen(par.axiom, par.gens, par.rules);
	actionType res = gen.generate();

	Lsgrinter inter(outname, res, par.forwards, par.angle);
	
	if(inter.draw())
		return 0;
	else {
		std::cout << inter.error << std::endl;
	}

}

